unit FavoriteModule;

{Ȃ肢ȂCɓ}

interface

uses
	Windows, SysUtils, ActiveX, ShlObj,
	{$IFNDEF EXTENSION}LObjects, {$ENDIF} EOFileIntf;

type
	TFavoriteActionItems = class;

	{V[gJbg}
	TFavoriteActionItem = class(TInterfacedObject, IActionItem)
	private
		FPath: TPath;
		FText: WideString;
		FChecked: Boolean;
		function GetText: WideString;
		function GetChecked: Boolean;
		function GetItems: IActionItems;
		function Execute: Boolean;
	public
		constructor Create(const ALinkFile: WideString; const Current: TPath);
		destructor Destroy; override;
	end;

	{fBNg}
	TFavoriteDirActionItem = class(TInterfacedObject, IActionItem)
	private
		FItems: TFavoriteActionItems;
		function GetText: WideString;
		function GetChecked: Boolean;
		function GetItems: IActionItems;
		function Execute: Boolean;
	public
		constructor Create(const ADir: WideString);
		destructor Destroy; override;
	end;

	TFavoriteActionItems = class(TInterfacedObject, IActionItems)
	private
		FItems: array of IActionItem;
		FDir: WideString;
		FNeedUpdate: Boolean;
		function GetTitle: WideString;
		function IActionItems.Enumerate = EnumerateItems;
		function EnumerateItems(Proc: CEachActionItem; Context: Pointer): IActionItem;
		procedure PostUpdate;
	public
		constructor Create(const ADir: WideString);
		procedure Update;
	end;

	TFavoriteAction = class(TInterfacedObject, IAction, IObserver)
	private
		FItems: TFavoriteActionItems;
		{IActionItem}
		function GetText: WideString;
		function GetChecked: Boolean;
		function GetItems: IActionItems;
		function Execute: Boolean;
		{IAction}
		function GetName: string;
		function GetHint: WideString;
		function GetEnabled: Boolean;
		{IObserver}
		procedure Observe;
	public
		constructor Create;
		destructor Destroy; override;
	end;

const
	FavoriteName = 'Favorite';

implementation

function WideExtractFileName(const S: WideString): WideString;
var
	I: Integer;
begin
	{ȈՎȂ̂œĂɂȂ悤.
	 CɓFavorite\fBNgȉŃtpXɂ͏\̕܂܂̂
	 łOK̂͂}
	Result := S;
	for I := Length(Result) downto 1 do
		if Result[I] = '\' then
		begin
			Delete(Result, 1, I);
			Break
		end;
end;

{ TFavoriteActionItem }

constructor TFavoriteActionItem.Create(const ALinkFile: WideString; const Current: TPath);
begin
	inherited Create;

	FPath := (GetApplication as IFolderManager).LinkToPath(ALinkFile);

	FText := WideExtractFileName(ALinkFile);
	{gq.lnk̂͂Ȃ̂ŌߑłŎ菜}
	Delete(FText, Length(FText) - 3, 4);

	if Current.Archive <> '' then
		FChecked := False
	else if Current.ItemIDList <> nil then
	begin
		{r͎̋ƂƂIShellFolderSHKv̂łڂ^^}
		FChecked := False
	end
	else
		FChecked := (FPath.ItemIDList = nil) and (FPath.Directory = Current.Directory)
end;

destructor TFavoriteActionItem.Destroy;
begin
	if FPath.ItemIDList <> nil then CoTaskMemFree(FPath.ItemIDList);
	inherited;
end;

function TFavoriteActionItem.Execute: Boolean;
var
	F: IFolder;
	V: IView;
	ParentPath: TPath;
begin
	(GetApplication as IReadWriteSyncEx).BeginWrite;
	try
		V := (GetCurrentThread as IEOFileThread).ActiveView;
		F := (GetApplication as IFolderManager).GetFolder(FPath);
		if F.Valid then
			V.Model := F
		else
		begin
			ParentPath := F.GetParentPath;
			V.Model := (GetApplication as IFolderManager).GetFolder(ParentPath);
			if ParentPath.ItemIDList <> nil then CoTaskMemFree(ParentPath.ItemIDList);

			if Supports(F, INameSpace) then
				V.FocusTo(F.DisplayText)
			else
				V.FocusTo(WideExtractFileName(FPath.Directory));
		end;
	finally
		(GetApplication as IReadWriteSyncEx).EndWrite
	end;
	Result := True;
end;

function TFavoriteActionItem.GetChecked: Boolean;
begin
	Result := FChecked
end;

function TFavoriteActionItem.GetItems: IActionItems;
begin
	Result := nil
end;

function TFavoriteActionItem.GetText: WideString;
begin
	Result := FText
end;

{ TFavoriteDirActionItem }

constructor TFavoriteDirActionItem.Create(const ADir: WideString);
begin
	inherited Create;
	FItems := TFavoriteActionItems.Create(ADir);
	FItems._AddRef
end;

destructor TFavoriteDirActionItem.Destroy;
begin
	FItems._Release;
	inherited;
end;

function TFavoriteDirActionItem.Execute: Boolean;
begin
	Result := False
end;

function TFavoriteDirActionItem.GetChecked: Boolean;
begin
	Result := False
end;

function TFavoriteDirActionItem.GetItems: IActionItems;
begin
	Result := FItems
end;

function TFavoriteDirActionItem.GetText: WideString;
begin
	Result := WideExtractFileName(FItems.FDir)
end;

{ TFavoriteActionItems }

constructor TFavoriteActionItems.Create(const ADir: WideString);
begin
	inherited Create;
	FDir := ADir;
  FNeedUpdate := True
end;

function TFavoriteActionItems.EnumerateItems(Proc: CEachActionItem; Context: Pointer): IActionItem;
var
	I: Integer;
begin
	if FNeedUpdate then
	begin
		FNeedUpdate := False;
		Update;
	end;
	for I := Low(FItems) to High(FItems) do
	begin
		Result := FItems[I];
		if Proc(Result, Context) then Exit;
	end;
	Result := nil
end;

function TFavoriteActionItems.GetTitle: WideString;
begin
	Result := 'Cɓ'
end;

procedure TFavoriteActionItems.PostUpdate;
begin
	FNeedUpdate := True
end;

procedure TFavoriteActionItems.Update;
var
	F: WIN32_FIND_DATAW;
	H: THandle;
	Item: IActionItem;
	View: IView;
	D, I, J: Integer;
begin
	FItems := nil;

	View := (GetCurrentThread as IEOFileThread).ActiveView;

	H := FindFirstFileW(PWideChar(FDir + '\*'), F);
	if H <> INVALID_HANDLE_VALUE then
	begin
		repeat
			if (F.dwFileAttributes and faDirectory <> 0) and
				((F.cFileName[0] <> '.') or
				((F.cFileName[1] <> '.') and (F.cFileName[1] <> #0))) then
			begin
				Item := TFavoriteDirActionItem.Create(FDir + '\' + F.cFileName);
				SetLength(FItems, Length(FItems) + 1);
				FItems[High(FItems)] := Item;
			end;
		until not FindNextFileW(H, F);
		Windows.FindClose(H);
	end;

	for I := Low(FItems) + 1 to High(FItems) do
		for J := I - 1 downto Low(FItems) do
		begin
			if WideCompareText(FItems[J].Text, FItems[J + 1].Text) < 0 then Break;
			Item := FItems[J];
			FItems[J] := FItems[J + 1];
			FItems[J + 1] := Item;
		end;

	D := Low(FItems) + Length(FItems);

	H := FindFirstFileW(PWideChar(FDir + '\*.lnk'), F);
	if H <> INVALID_HANDLE_VALUE then
	begin
		repeat
			try
				Item := TFavoriteActionItem.Create(FDir + '\' + F.cFileName, View.Model.Path);
				SetLength(FItems, Length(FItems) + 1);
				FItems[High(FItems)] := Item;
			except
				{...}
			end;
		until not FindNextFileW(H, F);
		Windows.FindClose(H);
	end;

	for I := D + 1 to High(FItems) do
		for J := I - 1 downto D do
		begin
			if WideCompareText(FItems[J].Text, FItems[J + 1].Text) < 0 then Break;
			Item := FItems[J];
			FItems[J] := FItems[J + 1];
			FItems[J + 1] := Item;
		end;
end;

{ TFavoriteAction }

constructor TFavoriteAction.Create;
var
	P, L: array[0..MAX_PATH] of WideChar;
	A: DWORD;
begin
	inherited Create;

	if SHGetSpecialFolderPathW(0, P, CSIDL_FAVORITES, False) then
	begin
		L := P;
		lstrcatW(L, '\local');
		A := GetFileAttributesW(L);
		if (Integer(A) <> -1) and (A and faDirectory <> 0) then
			P := L;

		FItems := TFavoriteActionItems.Create(P);
		FItems._AddRef;
	end;
end;

destructor TFavoriteAction.Destroy;
begin
	if FItems <> nil then FItems._Release;
	inherited;
end;

function TFavoriteAction.Execute: Boolean;
var
	Selected: IActionItem;
begin
	Result := GetEnabled;
	if Result then
	begin
		Selected := (GetApplication as IActionManager).Select(FItems);
		if Selected <> nil then Selected.Execute
	end
end;

function TFavoriteAction.GetChecked: Boolean;
begin
	Result := False
end;

function TFavoriteAction.GetEnabled: Boolean;
begin
	Result := FItems <> nil
end;

function TFavoriteAction.GetHint: WideString;
begin
	Result := 'Cɓ'
end;

function TFavoriteAction.GetItems: IActionItems;
begin
	Result := FItems
end;

function TFavoriteAction.GetName: string;
begin
	Result := FavoriteName
end;

function TFavoriteAction.GetText: WideString;
begin
	Result := 'Cɓ'
end;

procedure TFavoriteAction.Observe;
begin
	if (FItems <> nil) then
		FItems.PostUpdate
end;

end.
