unit ToXXXModule;

interface

uses
	Windows, ActiveX, ShlObj, SysUtils,
	{$IFNDEF EXTENSION}LObjects, {$ENDIF} EOFileIntf;

type
	TToRecycleBinAction = class(TInterfacedObject, IAction, IObserver)
	private
		FEnabled: Boolean;
		{IActionItem}
		function GetText: WideString;
		function GetChecked: Boolean;
		function GetItems: IActionItems;
		function Execute: Boolean;
		{IAction}
		function GetName: string;
		function GetHint: WideString;
		function GetEnabled: Boolean;
		{IObserver}
		procedure Observe;
	end;

implementation

var
	BitbucketPath: PItemIDList;

function GetNextItemID(ItemIDList: PItemIDList): PItemIDList;
begin
	if ItemIDList^.mkid.cb = 0 then
		Result := nil
	else
	begin
		Result := ItemIDList;
		Inc(PByte(Result), ItemIDList^.mkid.cb);
	end;
end;

function GetItemIDListSize(ItemIDList: PItemIDList): Integer;
begin
	if ItemIDList = nil then
	begin
		Result := 0;
		Exit;
	end;

	Result := SizeOf(ItemIDList^.mkid.cb);
	while ItemIDList^.mkid.cb <> 0 do
	begin
		Inc(Result, ItemIDList^.mkid.cb);
		ItemIDList := GetNextItemID(ItemIDList);
	end;
end;

{ TToRecycleBinAction }

function TToRecycleBinAction.Execute: Boolean;
var
	P: TPath;
begin
	SHGetSpecialFolderLocation(0, CSIDL_BITBUCKET, P.ItemIDList);
	try
		(GetCurrentThread as IEOFileThread).ActiveView.Model := (GetApplication as IFolderManager).GetFolder(P)
	finally
		CoTaskMemFree(P.ItemIDList)
	end;
	Result := True;
end;

function TToRecycleBinAction.GetChecked: Boolean;
begin
	Result := False
end;

function TToRecycleBinAction.GetEnabled: Boolean;
begin
	Result := FEnabled
end;

function TToRecycleBinAction.GetHint: WideString;
begin
	Result := 'ݔɈړ܂'
end;

function TToRecycleBinAction.GetItems: IActionItems;
begin
	Result := nil
end;

function TToRecycleBinAction.GetName: string;
begin
	Result := 'ToRecycleBin'
end;

function TToRecycleBinAction.GetText: WideString;
begin
	Result := 'ݔɈړ'
end;

procedure TToRecycleBinAction.Observe;
var
	P: TPath;
begin
	P := (GetCurrentThread as IEOFileThread).ActiveView.Model.Path;
	FEnabled := (P.ItemIDList = nil) or
		not CompareMem(P.ItemIDList, BitbucketPath, GetItemIDListSize(BitbucketPath));
end;

initialization

	SHGetSpecialFolderLocation(0, CSIDL_BITBUCKET, BitbucketPath)

finalization

	CoTaskMemFree(BitbucketPath)

end.
